﻿using System;
using System.ServiceModel.Description;
using Microsoft.Xrm.Sdk;
using Microsoft.Xrm.Sdk.Client;

namespace XrmLibrary.Adapters
{
    public abstract class ServiceAdapterBase<TService> : ServiceProxy<TService> where TService : class
    {
        protected ServiceAdapterBase(IServiceConfiguration<TService> serviceConfiguration, ClientCredentials clientCredentials) : base(serviceConfiguration, clientCredentials)
        {
        }

        protected ServiceAdapterBase(IServiceConfiguration<TService> serviceConfiguration, SecurityTokenResponse securityTokenResponse) : base(serviceConfiguration, securityTokenResponse)
        {
        }

        protected ServiceAdapterBase(Uri uri, Uri homeRealmUri, ClientCredentials clientCredentials, ClientCredentials deviceCredentials) : base(uri, homeRealmUri, clientCredentials, deviceCredentials)
        {
        }
    }
}
